//
//  Registration.swift
//  UnilProject
//
//  Created by Arielle Moro on 17.12.16.
//  Copyright © 2016 Arielle. All rights reserved.
//

import Foundation

class Registration : NSObject {
    
    var student: Student
    var course: Course
    var grade: Double
    var validated: Bool
    
    //Constructor redefinition
    init(withStudent student: Student, andCourse course: Course) {
        self.student = student
        self.course = course
        self.grade = 0.0
        self.validated = false
        super.init()
        student.addNewCourse(course: course)
        course.addNewRegistration(registration: self)
    }
    
    //Function enabling to set the grade
    func setGrade(grade: Double){
        self.grade = grade
    }
    
    //Function that validates the course for the student registered
    func setValidation(){
        validated = true
        student.updateCreditNumber(creditNumber: course.creditNumber)
        student.displayNotification(notification: "You have passed the course " + course.description + " with the grade \(grade)/6.0")
        student.storeCourse(course: course, grade: grade)
    }
    
}
