//
//  Student.swift
//  UnilProject
//
//  Created by Arielle Moro on 17.12.16.
//  Copyright © 2016 Arielle. All rights reserved.
//

import Foundation

class Student: UnilMember {
    
    var studentID: Int
    var creditNumber: Int
    var currentCourses: [Course]
    var validatedCourses : [Course: Double]
    
    //Constructor redefinition
    init(withFirstname firstname: String, andLastname lastname: String, andStudentID studentID: Int) {
        self.studentID = studentID
        self.creditNumber = 0
        self.currentCourses = []
        self.validatedCourses = [:]
        super.init(withFirstname: firstname, andLastname: lastname)
    }
    
    //Function updating the number of credits obtained by the student
    func updateCreditNumber(creditNumber: Int) {
        self.creditNumber += creditNumber
    }
    
    //Function adding a new course to the array of courses followed by a student
    func addNewCourse(course: Course) {
        currentCourses.append(course)
    }
    
    //Function that stores the course passed by the student
    func storeCourse(course: Course, grade: Double) {
        if(currentCourses.contains(course)) {
            validatedCourses[course] = grade
            currentCourses = currentCourses.filter(){$0 != course}
        }
    }
    
    //Funtion that prints a notification received
    func displayNotification(notification: String) {
        print("Notification sent to " + super.description + " => \(notification)")
    }
    
    //Description redefinition
    override var description : String {
        return super.description + " (studentID: \(studentID) - \(creditNumber) credit(s) obtained - current courses: " + currentCourses.description + " - validated courses: " + validatedCourses.description + ")"
    }
    
}
