//
//  ViewController.swift
//  UnilProject
//
//  Created by Arielle Moro on 16.12.16.
//  Copyright © 2016 Arielle. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    @IBAction func startUnilProject(_ sender: Any) {
        //1. Create 4 students
        let student1: Student = Student.init(withFirstname: "A", andLastname: "C", andStudentID: 1)
        let student2: Student = Student.init(withFirstname: "Y", andLastname: "B", andStudentID: 2)
        let student3: Student = Student.init(withFirstname: "B", andLastname: "M", andStudentID: 3)
        let student4: Student = Student.init(withFirstname: "L", andLastname: "Z", andStudentID: 4)
        //2. Create 1 professor as well as a course
        let professor: Professor = Professor.init(withFirstname: "B", andLastname: "G", andDepartment: "IS")
        let course: Course = Course.init(withName: "ACT", andCreditNumber: 6, andProfessor: professor)
        //3. These 4 students register for the course, i.e., create 4 registrations
        _ = Registration.init(withStudent: student1, andCourse: course)
        _ = Registration.init(withStudent: student2, andCourse: course)
        _ = Registration.init(withStudent: student3, andCourse: course)
        _ = Registration.init(withStudent: student4, andCourse: course)
        //4. Display the list of students based on the registrations, the professor perform the exam, set the grades of the students and the notifications are sent to the students
        //Print the students of the created course
        var index = 0
        for registration in course.getRegistrations(courseName: "ACT") {
            print("Registration n°\(index) " + registration.student.description)
            index += 1
        }
        //Perform the exam
        course.performExam()
        //Set the grades
        course.setGrade(studentID: 1, grade: 6.0)
        course.setGrade(studentID: 2, grade: 6.0)
        course.setGrade(studentID: 3, grade: 3.5)
        course.setGrade(studentID: 4, grade: 4.0)
        //Display exam stats
        course.displayExamStats()
        //Finish the semester
        course.finishSemester()
        //Display the status of all students
        index = 0
        for registration in course.getRegistrations(courseName: "ACT") {
            print("Registration n°\(index) " + registration.student.description)
            index += 1
        }
        //RETAKE STEP => Perform the exam
        course.performExam()
        //Set the grades
        course.setGrade(studentID: 3, grade: 5.5)
        //Display exam stats
        course.displayExamStats()
        //Finish the semester
        course.finishSemester()
        //Display the status of all students
        index = 0
        for registration in course.getRegistrations(courseName: "ACT") {
            print("Registration n°\(index) " + registration.student.description)
            index += 1
        }
    }

}

