/**
  * Created by ariellemoro on 12.12.16.
  */

class Registration(private var student: Student, private var course: Course) {

  private var grade: Double = 0.0
  private var validated: Boolean = false

  //Methods executed just after the creation of the a Registration object
  student.addNewCourse(course)
  course.addNewRegistration(this)

  //Getter: student
  def getStudent(): Student = {
    return student
  }

  //Getter: course
  def getCourse(): Course = {
    return course
  }

  //Getter: grade
  def getGrade(): Double = {
    return grade
  }

  //Setter: grade
  def setGrade(grade:Double): Unit = {
    this.grade = grade
  }

  //Function that validates the course for the student registered
  def setValidation(): Unit = {
    validated = true
    student.updateCreditNumber(course.getCreditNumber())
    student.displayNotification(s"You have passed the course ${course.toString} with the grade $grade/6.0")
    student.storeCourse(course, grade)
  }

}
