/**
  * Created by ariellemoro on 12.12.16.
  */

import scala.collection.mutable.{ListBuffer, Map}

class Student(private var firstname:String, private var surname:String, private var studentID:Int) extends UnilMember(firstname, surname) {

  private var creditNumber: Int = 0
  private var currentCourses:ListBuffer[Course] = new ListBuffer[Course]
  private var validatedCourses:ListBuffer[Map[Course, Double]] = new ListBuffer[Map[Course, Double]]

  //Getter: studentID
  def getStudentID: Int = {
    return studentID
  }

  //Function updating the number of credits obtained by the student
  def updateCreditNumber(creditNumber:Int): Unit = {
    this.creditNumber += creditNumber
  }

  //Function adding a new course to the array of courses followed by a student
  def addNewCourse(course: Course): Unit = {
    currentCourses += course
  }

  //Function that stores the course passed by the student
  def storeCourse(course: Course, grade: Double): Unit = {
    if(currentCourses.contains(course)) {
      validatedCourses += Map(course -> grade)
      currentCourses -= course
    }
  }

  //Function that prints a notification received
  def displayNotification(notification:String): Unit ={
    println(s"Notification sent to ${super.toString} => $notification")
  }

  override def toString: String = {
    return s"${super.toString} (student ID: $studentID - $creditNumber credit(s) obtained - current courses: ${currentCourses.toString()} - validated courses: ${validatedCourses.toString()})"
  }

}
