#Unil Member Class
class UnilMember(object):
    def __init__(self, firstname, lastname):
        self.firstname = firstname
        self.lastname = lastname


#Student Class inheriting from the UnilMember Class
class Student(UnilMember):
    def __init__(self, firstname, lastname, studentID):
        UnilMember.__init__(self, firstname, lastname)
        self.studentID = studentID
        self.creditNumber = 0
        self.currentCourses = []
        self.validatedCources = []

    def getstudentID(self):
        return self.studentID

    def updatecreditNumber(self, creditNumber):
        self.creditNumber += creditNumber

    def addNewCourse(self, course):
        self.currentCourses.append(course)

    def storeCourse(self, course, grade):
        if course in self.currentCourses:
            self.validatedCources.append([course, grade])
            self.currentCourses.remove(course)

    def displayNotification(notification):
        print 'Notification sent to %s' %notification  #Edit this method to send the correct notification


#Class Professor
class Professor(UnilMember):
    def __init__(self, firstname, lastname, department):
        UnilMember.__init__(self, firstname, lastname)
        self.department = department

#Course Class
class Course(object):
    def __init__(self, name, creditNumber, professor):
        self.name = name
        self.creditNumber = creditNumber
        self.professor = professor
        self.examperformed = False
        self.registrations = []

    def getCreditNumber(self):
        return self.creditNumber

    def perfromExam(self):
        self.examperformed = True

    def addNewRegistration(self, registration):
        self.registrations.append(registration)

    def displayExamStats(self):
        if(self.examperformed):
            self.sumGrade = 0
            self.successNB = 0
            self.failureNB = 0

            for i in range(0, len(self.registrations)):
                self.sumGrade += Registration.getGrade(self)
                if(Registration.getGrade(self) > 4.0):
                    self.successNB+=1
                else:
                    self.failureNB+=1

            self.successRate = float(self.successNB)/len(self.registrations)
            self.failurerate = float(self.failureNB)/len(self.registrations)
            self.examMean = float(self.sumGrade)/len(self.registrations)

            if(self.examperformed):
                print('examperformed')
            else:
                print('exam not performed')


    def getRegistrations(self):
        self.registrations



    def setGrade(self, studentID, grade):
        if(self.examperformed):
            for i in range(0, len(self.registrations)):
                currentstudent = Registration.getstudent(self)
                if(currentstudent.getstudentID == studentID):
                    Registration.setGrade(grade)
                if(grade>4.0):
                    Registration.setValidation(self)
                else:
                    currentstudent.displayNotifications('Exam Not passed')


    def finishSemester(self):
        if(self.examperformed):
            self.examperformed = False
            for i in range(0, len(self.registrations)):
                if(Registration.getGrade(self)>4.0):
                    pass


#Registration Class
class Registration(Student, Course):
    def __init__(self, student, course):
        #Student.__init__(self, self.firstname, self.lastname, self.studentID)
        #Course.__init__(self, self.name, self.creditNumber, self.professor)

        self.student = student
        self.course = course
        self.grade = 0
        self.validated = False

        self.student.addNewCourse(self)

        self.course.addNewRegistration(self)

    def getstudent(self):
       return self.student

    def getGrade(self):
        self.grade

    def setGrade():
        self.grade = grade

    def setValidation(self):
        self.validated = True
        self.student.updatecreditNumber(self, self.course.getCreditNumber(self))
        self.student.displayNotification('you have passed the course')
        self.student.storeCourse(self, self.course, self.grade)

#Change here to instantiate the student, course and registration cources

def UnilProject():

    stu1 = Student('A', 'C', 1)
    stu2 = Student('A', 'B', 2)

    prof1 = Professor('B', 'G', 'IS')

    c1 = Course('ACT', 6, 'prof1')

    reg1 = Registration(stu1, c1)

    #Course.perfromExam(c1)

    Course.setGrade(c1, 1, 6)

    Course.displayExamStats(c1)

    Course.finishSemester(c1)

if __name__ == "__main__":UnilProject()